IF db_name()<>'master' and
   exists (     select * from INFORMATION_SCHEMA.TABLES
          where table_name='Invoices' and table_type='BASE TABLE')
BEGIN
     drop table Invoices;
end;


create table Invoices
(
	Id bigint Identity(1,1) not null,
	CustomerNo Int not null default '',
	InvoiceNo Int not null default '',
	Date datetime not null default '1900-01-01'	
)

insert into Invoices(CustomerNo,InvoiceNo,Date) values(12,1,'2009-01-07');
insert into Invoices(CustomerNo,InvoiceNo,Date) values(15,2,'2009-02-08');
insert into Invoices(CustomerNo,InvoiceNo,Date) values(13,3,'2009-03-09');
insert into Invoices(CustomerNo,InvoiceNo,Date) values(18,4,'2009-04-10');
insert into Invoices(CustomerNo,InvoiceNo,Date) values(18,5,'2009-05-11');
insert into Invoices(CustomerNo,InvoiceNo,Date) values(12,6,'2009-06-12');
insert into Invoices(CustomerNo,InvoiceNo,Date) values(13,7,'2009-07-13');

SELECT * FROM Invoices

--find first occurrence (first invoice)
select * from Invoices i
where not exists(select ii.Id 
				 from Invoices ii
				 where ii.CustomerNo=i.CustomerNo and
						ii.Id<i.Id
				)
order by i.CustomerNo

--find last occurrence (last invoice)
select * from Invoices i
where not exists(select ii.Id 
				 from Invoices ii
				 where ii.CustomerNo=i.CustomerNo and
						ii.Id>i.Id
				)
order by i.CustomerNo
